import { OnDestroy, OnInit, QueryList, TemplateRef } from '@angular/core';
import { ApiDataSource, ApiPageResponse, DataSourceRequest } from '@bravobit/bb-foundation/api';
import { Observable } from 'rxjs';
import { TableColumnSortStrategy } from '../table.interfaces';
import { FormControl } from '@angular/forms';
export declare class BbTableColumnDef {
}
export declare class BbTable implements OnInit, OnDestroy {
    tableColumnTemplates: QueryList<BbTableColumnDef>;
    headerTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    identifier: string | null;
    dataSource: ApiDataSource;
    queryFields: string[];
    sortingMode: 'single' | 'multiple';
    private _sizes;
    private _sort$;
    sizes: number[];
    private _header;
    private _footer;
    header: TemplateRef<any> | boolean;
    footer: TemplateRef<any> | boolean;
    trackByFn: (index: any, item: any) => any;
    trackByValue: (index: any, item: any) => any;
    request: DataSourceRequest;
    data$: Observable<{
        state: string;
        result?: ApiPageResponse;
    }>;
    isLoading$: Observable<boolean>;
    queryControl: FormControl;
    sizeControl: FormControl;
    pageControl: FormControl;
    private _subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    requestSort(name: string, direction: TableColumnSortStrategy): void;
    isSorting(name: string): Observable<TableColumnSortStrategy>;
    refresh(): void;
    private updateSizes;
    private subscribeToChanges;
    private getCombinedChangeObservables;
    private getQueryChanges;
    private getSizeChanges;
    private getPageChanges;
    private getSortChanges;
}
